using System;
using System.Collections;
using System.Text;
using System.Diagnostics;
using System.Xml;

namespace BizTalkBill.BizTalkHelpers
{
	public class Debugging
	{
		public static void WriteEventLog(String sSource, String sMessage, EventLogEntryType Severity)
		{
			try
			{
				EventLog.WriteEntry(sSource, sMessage, Severity, 0);
			}
			catch
			{
				// prevent event log being full from crashing application
			}
		}
		public static void WriteEventLog(String sSource, String sMessage)
		{
			WriteEventLog(sSource, sMessage, EventLogEntryType.Information);
		}

		public static void WriteEventLog(String sMessage)
		{
			WriteEventLog(System.AppDomain.CurrentDomain.ToString(), sMessage, EventLogEntryType.Information);
		}

		public static void WriteEventLog(String sSource, XmlDocument xmlDoc, EventLogEntryType Severity)
		{
			WriteEventLog(sSource, xmlDoc.OuterXml, Severity);
		}

		public static void WriteEventLog(String sSource, string sMessage, XmlDocument xmlDoc, EventLogEntryType Severity)
		{
			WriteEventLog(sSource, sMessage + " : " + xmlDoc.OuterXml, Severity);
		}

		public static void WriteEventLog(XmlDocument xmlDoc, EventLogEntryType Severity)
		{
			WriteEventLog(System.AppDomain.CurrentDomain.ToString(), xmlDoc.OuterXml, Severity);
		}
	}
}
