using System;
using System.Collections;
using System.Text;
using System.Xml;

namespace BizTalkBill.BizTalkHelpers
{
    public class Message
    {
        public static XmlDocument CreateSchemaInstance(string sSchemaName)
        {
            XmlDocument xmlResult = SchemaRetriever.GetInstanceForSchema(sSchemaName);
            return xmlResult;
        }
		public static XmlDocument AppendNode(string sDestinationXPath, XmlDocument xmlSource, XmlDocument xmlInsert)
		{
			XmlDocument xmlResult = xmlSource;

			XmlNode xmlInsertNode = xmlResult.SelectSingleNode(sDestinationXPath);

			if (xmlInsertNode != null)
			{
				xmlInsertNode.InnerXml = xmlInsertNode.InnerXml + xmlInsert.InnerXml;
			}

			return xmlResult;
		}

		public static XmlDocument ReplaceNode(string sDestinationXPath, XmlDocument xmlSource, XmlDocument xmlInsert)
		{
			XmlDocument xmlResult = xmlSource;

			XmlNode xmlInsertNode = xmlResult.SelectSingleNode(sDestinationXPath);

			if (xmlInsertNode != null)
			{
				xmlInsertNode.InnerXml = xmlInsert.InnerXml;
			}

			return xmlResult;
		}

		public static XmlDocument RemoveNodes(string sDestinationXPath, XmlDocument xmlSource)
		{
			XmlDocument xmlResult = xmlSource;

			XmlNode xmlInsertNode = xmlResult.SelectSingleNode(sDestinationXPath);

			if (xmlInsertNode != null)
			{
				xmlInsertNode.InnerXml = "";
			}

			return xmlResult;
		}
        
		public static XmlDocument ExtractNode(string sSourceXPath, XmlDocument xmlSource)
		{
			XmlDocument xmlResult = new XmlDocument();

			XmlNode xmlExtractNode = xmlSource.SelectSingleNode(sSourceXPath);

			if (xmlExtractNode != null)
			{
				xmlResult.LoadXml(xmlExtractNode.InnerXml);
			}

			return xmlResult;
		}
	}
}
